extends Object
class_name StopWatch

var _start_time : int


func _init(autostart : bool = false) -> void:
	restart()

## Restarts this [StopWatch].
func restart() -> void:
	_start_time = Time.get_ticks_usec()

## Returns the amount of time this [StopWatch] has been running, in microseconds.
func get_time_usecs() -> int:
	return Time.get_ticks_usec() - _start_time


## Returns the time since this [StopWatch] was created or restarted, as a [String], in the format [br][code]minutes mins, seconds secs, milliseconds msecs, microseconds usecs[/code].
func get_time_string() -> String:
	var time_usecs : int = get_time_usecs()
	var time_msecs : int = time_usecs / 1000
	var time_secs : int = time_msecs / 1000
	var time_mins : int = time_secs / 60
	var string : String = ""
	if time_usecs - (time_msecs * 1000) > 0:
		string += str(time_usecs - (time_msecs * 1000), " usecs")
	if time_msecs - (time_secs * 1000) > 0:
		string = str(time_msecs - (time_secs * 1000), " msecs, ") + string
	if time_secs - (time_mins * 60) > 0:
		string = str(time_secs - (time_mins * 60), " secs, ") + string
	if time_mins > 0:
		string = str(time_mins, " mins, ") + string
	if string == "":
		string = "< 1 usec"
	return string

## Returns the time since this [StopWatch] was created or restarted, in seconds.
func get_time_seconds() -> float:
	return get_time_usecs() / 1000000.0
